/*
 * init_cmap.c - color map init
 *
 * Copyright (c) 2010 ariel/KotCzarny
 *
 * This file is released under the GPLv2
 *
 */

#ifndef INC_init_cmap
#define INC_init_cmap

#ifndef USE_init_cmap
void init_cmap() {}
#else

#define cmap_len 256*6
union color cmap[cmap_len];

/////###########
void init_cmap() { int i; for(i=0;i<=255;i++) {
 cmap[i].s.r=i;         cmap[i].s.g=0;         cmap[i].s.b=0;
 cmap[i+256].s.r=255;   cmap[i+256].s.g=i;     cmap[i+256].s.b=0;
 cmap[i+256*2].s.r=255; cmap[i+256*2].s.g=255; cmap[i+256*2].s.b=i;
 cmap[i+256*3].s.r=255-i; cmap[i+256*3].s.g=255; cmap[i+256*3].s.b=255;
 cmap[i+256*4].s.r=0;	cmap[i+256*4].s.g=255-i; cmap[i+256*4].s.b=255;
 cmap[i+256*5].s.r=0;	cmap[i+256*5].s.g=0;	cmap[i+256*5].s.b=255-i;
}}

#endif
#endif
