/*
 * init_misc.c - misc functions (that run once per size change)
 *
 * Copyright (c) 2010 ariel/KotCzarny
 *
 * This file is released under the GPLv2
 *
 */

#ifndef INC_init_misc
#define INC_init_misc

#ifdef USE_misc

// runs on size change, also allows runnign pixo based inits
int init_misc(unsigned char *src, unsigned char *dst, unsigned char *buf2, unsigned char *buf3,
 int ww, int wh)
{
 if(ww!=xmax || wh!=ymax || map_inited<2) { map_inited++; xmax=ww; ymax=wh;
  csrc=(union color *)src; cdst=(union color *)dst;
  cbuf2=(union color *)buf2; cbuf3=(union color *)buf3;
  init_sint(); init_cmap(); // srand((int)time(NULL));
  return 1;
 } else return 0;
}

#endif
#endif
