/*
 * put_c.c - put pixel funcs (cmapped)
 *
 * Copyright (c) 2010 ariel/KotCzarny
 *
 * This file is released under the GPLv2
 *
 */

#ifndef INC_put_c
#define INC_put_c

#ifdef USE_put_c

#include <stdlib.h>

#define USE_swap
#include "./swap.c"

/////################################################################
void putp_c(unsigned int *B, int xmax, int ymax, int x, int y, int c)
{ if(x<0 || x>=xmax || y<0 || y>=ymax) return; B[x+y*xmax]+=c; }

/////##################################################################################
void putl_c(unsigned int *B, int xmax, int ymax, int x0, int y0, int x1, int y1, int c) {
// int X1=x1,Y1=y1,X0=x0,Y0=y0;
// if(x0<0 || x0>=conf.ww || y0<0 || y0>=conf.wh) { return; }
// if(x1<0 || x1>=conf.ww || y1<0 || y1>=conf.wh) { return; }
 int x, steep = abs(y1 - y0) > abs(x1 - x0);
 if(steep) { swapi(&x0, &y0); swapi(&x1, &y1); }  if(x0 > x1) { swapi(&x0, &x1); swapi(&y0, &y1); }
 int deltax = x1 - x0, deltay = abs(y1 - y0); int error = deltax / 2; int ystep, y = y0;
 if(y0 < y1) ystep = 1; else ystep = -1;
 for(x=x0; x<x1; x++)
 { if(steep) putp_c(B,xmax,ymax,y,x,c); else putp_c(B,xmax,ymax,x,y,c);
  error = error - deltay; if(error < 0) { y = y + ystep; error = error + deltax; }
 }
// if(conf.lines==3) putp(where,0,Y0,X0,conf.cw);
// if(conf.lines==2) putp(where,0,Y1,X1,conf.cw);
}

#endif
#endif
