export LD_LIBRARY_PATH=g
export PATH=g:$PATH

P="$*";
rm 2>/dev/null "$P.o" "$P.so";

exec >/tmp/osc-pix.err 2>&1
echo -e "\n  [$P]"

./g/gcc -Bg -O3 -fomit-frame-pointer -ffast-math -Wall -fPIC -Ig/include -c "$P.c" -o "$P.o" && \
./g/gcc -shared -Lg -L/lib -L/usr/lib -Wl,-soname,osc-pix.so -o "$P.so" "$P.o" && \
rm "$P.o";
