// [o] lens rings

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 int o, x, y, ww2=ww/2, wh2=wh/2; float *map=(float *)buf3, x1,y1,fr;

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform map..");
 if(mbuf[4]==0) {mbuf[0]=ww2; mbuf[1]=wh2;}
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
   x1=3.416*(x-ww2)/ww2;
   y1=3.416*(y-wh2)/wh2;
   fr=sqrt(x1*x1+y1*y1);
   map[o]=cos(fr*5.0)*fr;
  }
 }
 printf("..done\n");
}

int i,c1,c2,c3,c4,x0,y0; float px,py,Px,Py;
memset(dst,0,ww*4); memset(dst+ww*(wh-1)*4,0,ww*4);
for(i=0;i<wh;i++){ memset(dst+(i*ww*4),0,4); memset(dst+(i*ww*4+(ww-1)*4),0,4); }

if(1) for(y=1; y<wh-1; y++) { for(x=1; x<ww-1; x++) { o=x+y*ww;

 x1=x+3.0*map[o]*(map[o+1]-map[o]);
 y1=y+3.0*map[o]*(map[o+ww]-map[o]);

 if(x1<0 || x1>=ww || y1<0 || y1>=wh) { o=4*(x+y*ww); dst[o]=0; dst[o+1]=0; dst[o+2]=0; continue;}

 x0=(int)(x1);y0=(int)(y1); Px=x1-x0; px=1.0-Px;Py=y1-y0; py=1.0-Py;

 o*=4; for(i=2;i>=0;i--)
 {
  c1=src[i+(x0  +y0*ww)*4];
  c2=src[i+(x0+1+y0*ww)*4];
  c3=src[i+(x0  +(y0+1)*ww)*4];
  c4=src[i+(x0+1+(y0+1)*ww)*4];
  dst[i+o]=( (c1*px+c2*Px)*py + (c3*px+c4*Px)*Py )*0.99;
 }

}}

}
