#include <stdio.h>
#include <stdlib.h>
#include <math.h>
// map: rotation && zooming

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ int rx=rand()*100.0/RAND_MAX; // int ry=rand()*100.0/RAND_MAX;
 int o, o1, x, y, x1, y1, dx=bpp, dy=bpp*ww;
 int ww2=ww/2, wh2=wh/2;
 int *map=buf3;
 float a=map[ww*wh+3]
*(450.0-fbuf[144])/32.0
*(450.0-fbuf[10])/2.0/wh2, b=3.1416/2.0/wh;
 if(rx==1) map[ww*wh+3]*=-1; //printf("\n%d\n", map[ww*wh+3]);

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform map..");
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 float fx=0.0,fy=0.0,fr;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
   fx=b*(x-ww2);
   fy=b*(y-wh2);
   fr=64*sqrt(fx*fx+fy*fy);

   x1=x-fr*sin(fy);
   y1=y+fr*sin(fx);

   if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
   map[o]=o1;
  }
 }
 printf("..done\n");
}

 // apply map transform
 for(y=0; y<wh; y++) {
  for(x=0; x<ww; x++) { o1=x+y*ww; o=o1*4; // o - mem offset, 0 <= o <= (ww*dx+y*dy-1)
    buf2[0+o]=buf2[0+o]*4/32+src[0+map[o1]]*26/32; // blue
    buf2[1+o]=buf2[1+o]*4/32+src[1+map[o1]]*26/32; // green
    buf2[2+o]=buf2[2+o]*4/32+src[2+map[o1]]*26/32; // red
 }}

 // apply effect
 for(y=0; y<wh; y++) {
  for(x=0; x<ww; x++) { o=x*dx+y*dy; // o - mem offset, 0 <= o <= (ww*dx+y*dy-1)
   x1=x+(x-ww2)*a;
   y1=y+(y-wh2)*a;

   if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
    dst[0+o]=buf2[0+o1]; // blue
    dst[1+o]=buf2[1+o1]; // green
    dst[2+o]=buf2[2+o1]; // red
  }
 }

}
