// disco glow

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

#define swap(a,b) a ^= b ^= a ^= b;
#define MAX(a,b) (a>b?a:b)
#define MIN(a,b) (a<b?a:b)
#define CLIP(m,M,a) MAX(m,MIN(M,a))

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[360*100];
float sint(float a) {
 int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
// int a1=((int)(a*0.0000176838826))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
}
float cost(float a) { return sint(a+3.14159265/2.0); }

int ra(int rm) { if(rm<=0) return 0; else return rand()%rm; }
void pl(union color *t, int ww, int x, int y, int w, int h) { if(w<2&&h<2) return;
// printf("[x:%d y:%d ww:%d w:%d h:%d] ",x,y,ww,w,h);
 int o=x+y*ww,w2=w/2,h2=h/2,wr=w/2,hr=2;
 int r;
 r=ra(hr)-1+(t[o].s.r+t[o+w].s.r)/2; t[o+w2].s.r=CLIP(0,255,r);
 r=ra(hr)-1+(t[o+h*ww].s.r+t[o+w+h*ww].s.r)/2; t[o+w2+h*ww].s.r=CLIP(0,255,r);
 r=ra(hr)-1+(t[o].s.r+t[o+h*ww].s.r)/2; t[o+h2*ww].s.r=CLIP(0,255,r);
 r=ra(hr)-1+(t[o+w].s.r+t[o+w+h*ww].s.r)/2; t[o+w+h2*ww].s.r=CLIP(0,255,r);
 r=ra(h*4)-h/2 +(t[o+w2].s.r+t[o+w2+h*ww].s.r + t[o+h2*ww].s.r+t[o+w+h2*ww].s.r)/4;
  t[o+w2+h2*ww].s.r=CLIP(0,255,r);
 pl(t,ww,x   ,y,w2,h2);
 pl(t,ww,x+w2,y,w2,h2);
 pl(t,ww,x   ,y+h2,w2,h2);
 pl(t,ww,x+w2,y+h2,w2,h2);
}

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 union color *isrc=(union color *)src;
 union color *idst=(union color *)dst;
 int o, o1, x, y;
 int ww2=ww/2, wh2=wh/2;
 float *map=(float *)buf3;

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform cache..");
 if(mbuf[4]==0) {mbuf[0]=ww2; mbuf[1]=wh2;}
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
   map[o]=sqrt(x*x+y*y);
  }
 }
 for(x=0;x<36000;x++) sin_tab[x]=sin(2.0*3.14159265*x/36000.0);
 printf("..done\n");
}

 int s=96,r;
 for(y=0; y<wh-s; y+=s) { for(x=0; x<ww-s; x+=s) {
//  printf("[x:%d y:%d] ",x,y);
r=isrc[x+y*ww].s.r+ra(4)-1; isrc[x+y*ww].s.r=CLIP(0,255,r);
r=isrc[x+y*ww+s].s.r+ra(4)-1; isrc[x+y*ww+s].s.r=CLIP(0,255,r);
r=isrc[x+y*ww+s*ww].s.r+ra(4)-1; isrc[x+y*ww+s*ww].s.r=CLIP(0,255,r);
r=isrc[x+y*ww+s+s*ww].s.r+ra(4)-1; isrc[x+y*ww+s+s*ww].s.r=CLIP(0,255,r);
  pl(isrc,ww,x,y,s,s);
 }}
if(0) memcpy(dst,src,ww*wh*4);
else for(y=0; y<wh; y++) {
  for(x=0; x<ww; x++) { o1=x+y*ww; o=o1*4;
    dst[0+o]=+src[0+o]*63/64; // blue
    dst[1+o]=+src[1+o]*63/64; // green
    dst[2+o]=+src[2+o]*63/64; // red
}}

}
