// beat needles

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[36000];
float sint(float a) { int a1=((int)(a*0.0000176838826))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }

float acor=1500.0;

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ int x,y,r,g,b; unsigned int *idst=(unsigned int *)dst;
 union color c0,*csrc=(union color *)src;

 for(y=0; y<wh; y++) for(x=0; x<ww; x++)
 { r=0; g=0; b=0;
  { c0.i=csrc[x+y*ww].i;
   r+=abs(abuf[(x+y)*2]-abuf[(x+y+1)*2])*c0.s.r;
   g+=abs(abuf[(x+y+1)*2]-abuf[(x+y+2)*2])*c0.s.g;
   b+=abs(abuf[(x+y+2)*2]-abuf[(x+y+3)*2])*c0.s.b;
  }
  r/=acor; g/=acor; b/=acor;
//  if(r<0) r=0; if(r>255) r=255;
//  if(g<0) g=0; if(g>255) g=255;
//  if(b<0) b=0; if(b>255) b=255;
  idst[x+y*ww]=(r<<16)|(g<<8)|(b);
 }
}
