// kaleidoscope

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[36000]; static int sint_inited=0;
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { int i; for(i=0;i<36000;i++) sin_tab[i]=sin(2.0*3.14159265*i/36000.0); i=0; 
 sint_inited=1; printf("sint inited\n"); }


void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ int x,y,r,g,b; unsigned int *idst=(unsigned int *)dst;
 union color c0,*csrc=(union color *)src;
 if(!sint_inited) sint_init();

 int xx,yy;
 for(y=0; y<wh; y++) for(x=0; x<ww; x++)
 { r=0; g=0; b=0;
  {
c0.i=csrc[x+y*ww].i; r+=c0.s.r;g+=c0.s.g;b+=c0.s.b;
c0.i=csrc[ww-x+y*ww].i; r+=c0.s.r;g+=c0.s.g;b+=c0.s.b;
c0.i=csrc[x+(wh-y)*ww].i; r+=c0.s.r;g+=c0.s.g;b+=c0.s.b;
c0.i=csrc[ww-x+(wh-y)*ww].i; r+=c0.s.r;g+=c0.s.g;b+=c0.s.b;

 xx=y*ww/wh; yy=x*wh/ww;
c0.i=csrc[xx+yy*ww].i; r+=c0.s.r;g+=c0.s.g;b+=c0.s.b;
c0.i=csrc[ww-xx+yy*ww].i; r+=c0.s.r;g+=c0.s.g;b+=c0.s.b;
c0.i=csrc[xx+(wh-yy)*ww].i; r+=c0.s.r;g+=c0.s.g;b+=c0.s.b;
c0.i=csrc[ww-xx+(wh-yy)*ww].i; r+=c0.s.r;g+=c0.s.g;b+=c0.s.b;
  }
  r=r*63/512; g=g*63/512; b=b*63/512;

  idst[x+y*ww]=(r<<16)|(g<<8)|(b);
 }
}
