// simple color weave

#define MAX(a,b) (a>b?a:b)
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

int sint_inited=0; static float sin_tab[36000];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { if(sint_inited) return; sint_inited=1;
 int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }


void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ unsigned int *isrc=(unsigned int *)src, *idst=(unsigned int *)dst, *ibuf2=(unsigned int *)buf2;
 union color *csrc=(union color *)src, *cdst=(union color *)dst, c;
 int o,x,y; sint_init(); // if(mbuf[4]&0x400) {}

 for(y=0;y<wh;y++) for(x=0;x<ww;x++) { o=x+y*ww;
  c.s.r=sint(frame/4)*256+x-y; c.s.r=(c.s.r+csrc[o].s.r*7)/8;
  c.s.g=sint(frame/10)*256+x-y; c.s.g=(c.s.g+csrc[o].s.g*7)/8;
  c.s.b=sint(frame/7)*256+x+y; c.s.b=(c.s.b+csrc[o].s.b*7)/8;
  cdst[o].i=c.i;
 }


}
