const char get_title[128]	= "chaos (colormapped)";
const char get_version[16]	= "0.1";
const char get_author[32]	= "sierpinski, curious & KotCzarny";
const char get_description[1]	= "wider ns chance";

#define MAX(a,b) (a>b?a:b)
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

int sint_inited=0; static float sin_tab[36000];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { if(sint_inited) return; sint_inited=1;
 int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }




static int i=0,q=0,xmax,ymax; //,k=0,a=0,h=0;
static float z=0;
static double pp=0,r=0;
//static char filename[16];

static unsigned char ns=12;
static int xnn=0,ynn=0,xp=0,yp=0,xk=0,yk=0,dx=0,dy=0,x=0,y=0;
static float s11[5000], p[5000], s12[5000], s13[5000], s23[5000], s22[5000], s21[5000]; //, s31[50], s41[50];

unsigned short *ekran;

static int it;

double my_rand(float a) { return (1+(1.0*a*rand()/(RAND_MAX+1.0))); }
double my_frand() { return (rand()/(RAND_MAX+1.0)); }
void plot(int x, int y) { ekran[x+y*xmax]++; }
void cls() { memset(ekran, 0, xmax*ymax*2); }

void dump(void *dst) { int o;
// for(o=0;o<xmax*ymax;o++) { memset(dst+o*4
// int i,j;
// for(j=0;j<ymax;j++) { for(i=0;i<xmax;i++) {
//    image_buffer[i+j*xmax]=ekran[i][j];
// } }
// write_JPEG_file ("/dev/stdout", 50);
}

void g545() { double a;
 if (xp>xk) { a=xp; xp=xk; xk=a; a=yp; yp=yk; yk=a; } dx=fabs(xk-xp); dy=fabs(yk-yp);
 if (dy>dx) { 
  if (yp>yk) { a=xp; xp=xk; xk=a; a=yp; yp=yk; yk=a; }
  a=(xk-xp)/(yk-yp); for (y=yp;y<=yk;y+=5) { x=xp+a*(y-yp); } /* next y */
 } else { 
  if (xp>xk) { a=xp; xp=xk; xk=a; a=yp; yp=yk; yk=a; }
  a=(yk-yp)/(xk-xp); for (x=xp;x<=xk;x+=8) { y=yp+a*(x-xp); } /* next x */
 }
}

void g360(){ int i; double r1,r2,r3,xx[5],yy[5];
 for (i=1;i<=ns;i++){
  r1=my_frand()*(xmax);  r2=my_frand()*(xmax);  r3=my_frand()*(xmax);
  s11[i]=(r2-r1)/(xmax); s12[i]=(r3-r1)/(ymax); s13[i]=r1;
  r1=my_frand()*(ymax);  r2=my_frand()*(ymax);  r3=my_frand()*(ymax);
  s21[i]=(r2-r1)/(xmax); s22[i]=(r3-r1)/(ymax); s23[i]=r1;

  xx[0]=   0*s11[i]+   0*s12[i]+s13[i]; yy[0]=   0*s21[i]+   0*s22[i]+s23[i];
  xx[1]=xmax*s11[i]+   0*s12[i]+s13[i]; yy[1]=xmax*s21[i]+   0*s22[i]+s23[i];
  xx[2]=xmax*s11[i]+ymax*s12[i]+s13[i]; yy[2]=xmax*s21[i]+ymax*s22[i]+s23[i];
  xx[3]=   0*s11[i]+ymax*s12[i]+s13[i]; yy[3]=   0*s21[i]+ymax*s22[i]+s23[i];

  xp=xx[0]; yp=yy[0]; xk=xx[1]; yk=yy[1]; g545();
  xp=xx[2]; yp=yy[2]; xk=xx[1]; yk=yy[1]; g545();
  xp=xx[2]; yp=yy[2]; xk=xx[3]; yk=yy[3]; g545();
  xp=xx[0]; yp=yy[0]; xk=xx[3]; yk=yy[3]; g545();
 } /* next i */
}
void iteration() { }
void randomize() { ns=2+(int)(150*my_frand()); it=it*ns; }

static int cmap_len;
static union color cmap[2048];

int map_inited=0;
void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ //unsigned int *isrc=(unsigned int *)src, *ibuf2=(unsigned int *)buf2;
 unsigned int *idst=(unsigned int *)dst;
 //union color *csrc=(union color *)src, *cdst=(union color *)dst, c; c.i=0;
 int o,ri; //,x,y,ww2=ww/2,wh2=wh/2;
 sint_init();
 if(mbuf[4]&0x400) { r=0; usleep(100000); } // rmb

if(ww!=xmax || wh!=ymax || map_inited<2) { map_inited++; // FILE *f1; char conv[2048];
// sprintf(conv,"convert -resize %dx%d! spiral.png spiral.gray", ww,wh); system(conv);
// f1=fopen("spiral.gray", "r"); fread(buf3,ww*wh,1,f1); fclose(f1);
// for(o=0;o<ww*wh;o++) { memset(buf2+o*4,buf3[o],4); }

// srand((int)time(NULL));  
 r=0; ekran=buf2; xmax=ww; ymax=wh;
 int i; for(i=0;i<=255;i++)
{
 cmap[i].s.r=i;         cmap[i].s.g=0;         cmap[i].s.b=0;
 cmap[i+256].s.r=255;   cmap[i+256].s.g=i;     cmap[i+256].s.b=0;
 cmap[i+256*2].s.r=255; cmap[i+256*2].s.g=255; cmap[i+256*2].s.b=i;
 cmap[i+256*3].s.r=255-i; cmap[i+256*3].s.g=255;   cmap[i+256*3].s.b=255;
 cmap[i+256*4].s.r=0; cmap[i+256*4].s.g=255-i; cmap[i+256*4].s.b=255;
 cmap[i+256*5].s.r=0; cmap[i+256*5].s.g=0;   cmap[i+256*5].s.b=255-i;
} cmap_len=256*6;


}

if(r==0 || r>(10*ns)*1000000)
{ r=1;
 cls();
 q=0; it=10000; randomize(); g360();
 cls();

 pp=0; for (i=1;i<=ns;i++) { p[i]=fabs(s11[i]*s22[i]-s21[i]*s12[i])+0.3; pp+=p[i]; } 
 z=0; for (i=1;i<=ns;i++) { z=z+p[i]; p[i]=z/pp; } 
 x=0; ynn=0; xnn=0;
 z=0;
}

// for (r=1;r<(10*ns)*10000;r++)
 for(ri=1;ri<20000;ri++)
 { r++; z=rand()/(RAND_MAX+1.0); i=1;
// while (z>=p[i] && i!=ns) {i++;} 

  switch(ns%8){
	case 0:		if (z>=p[i]) {i++;};
	case 32:	if (z>=p[i]) {i++;};
	case 31:	if (z>=p[i]) {i++;};
	case 30:	if (z>=p[i]) {i++;};
	case 29:	if (z>=p[i]) {i++;} else break;
	case 28:	if (z>=p[i]) {i++;};
	case 27:	if (z>=p[i]) {i++;};
	case 26:	if (z>=p[i]) {i++;};
	case 25:	if (z>=p[i]) {i++;};
	case 24:	if (z>=p[i]) {i++;};
	case 23:	if (z>=p[i]) {i++;};
	case 22:	if (z>=p[i]) {i++;} else break;
	case 21:	if (z>=p[i]) {i++;};
	case 20:	if (z>=p[i]) {i++;};
	case 19:	if (z>=p[i]) {i++;};
	case 18:	if (z>=p[i]) {i++;};
	case 17:	if (z>=p[i]) {i++;};
	case 16:	if (z>=p[i]) {i++;};
	case 15:	if (z>=p[i]) {i++;} else break;
	case 14:	if (z>=p[i]) {i++;};
	case 13:	if (z>=p[i]) {i++;};
	case 12:	if (z>=p[i]) {i++;};
	case 11:	if (z>=p[i]) {i++;};
	case 10:	if (z>=p[i]) {i++;};
	case 9: 	if (z>=p[i]) {i++;};
	case 8: 	if (z>=p[i]) {i++;};
	case 7: 	if (z>=p[i]) {i++;} else break;
	case 6:		if (z>=p[i]) {i++;};
	case 5:		if (z>=p[i]) {i++;};
	case 4:		if (z>=p[i]) {i++;};
	case 3:		if (z>=p[i]) {i++;};
	case 2:		if (z>=p[i]) {i++;};
     }
	
	x=xnn;
	xnn=xnn*s11[i]+ynn*s12[i]+s13[i];
	ynn=  x*s21[i]+ynn*s22[i]+s23[i];
	//moved	x=xnn; 
	if (xnn<xmax && xnn>=0 && ynn>=0 && ynn<ymax) { plot((int)xnn,(int)ynn); }
    }
 q++; // sprintf (filename, "%d.jpg",q) ;dump(filename); 

 for(o=0; o<ww*wh; o++) { idst[o]=cmap[ekran[o]%cmap_len].i; }
}
