#include <stdio.h>
#include <string.h>
#include <time.h>

float dts(struct timespec ts, struct timespec ts0) { int ds; long int dn;
 if(ts0.tv_nsec > ts.tv_nsec) { ds=0; dn=0; } else { ds=1; dn=1000000000L; }
 return ts.tv_sec-ds-ts0.tv_sec + (ts.tv_nsec+dn-ts0.tv_nsec)*0.000000001;
}
void gts(struct timespec *tss) { clock_gettime(CLOCK_REALTIME, tss); }
void setfreq(char *fr) { FILE *f; printf("setting freq to: %s", fr);
 f=fopen("/sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq","w"); fwrite(fr,31,1,f); fclose(f);
}

#define S 800*480*2

//unsigned char
int
 s0[S], s1[S], dst[S];

int main() { struct timespec ts,ts0; int i=0; float d=0,d0=0;
 double t=0; t=S; t*=2; t/=1024.0*1024.0;
 char gmax[32],gmin[32]; FILE *f;
 f=fopen("/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq","r"); fread(gmax,31,1,f); fclose(f);
 f=fopen("/sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq","r"); fread(gmin,31,1,f); fclose(f);
printf("dst: %d\n", (int)(dst) % 4);
printf("s0: %d\n", (int)(s0) % 4);
printf("s1: %d\n", (int)(s1) % 4);

 setfreq(gmax); printf("buffer size: %5.2fM\n", S*2/1024.0/1024.0); gts(&ts0); while(d<=10.0)
 {
  memcpy(dst,s0,S);
  memcpy(dst,s1,S);
  i++;  gts(&ts);  d=dts(ts,ts0);
  if(d-d0>1.0) { d0=d;
   printf("i:%5d,  t:%5.2f,  memcpy:%.3f MB/s\n", i,d, t*i/d);
   fflush(NULL);
  }
 } setfreq(gmin);
 printf("i:%5d,  t:%5.2f,  memcpy:%.3f MB/s\n", i,d, t*i/d);

 return 0;
}
