/*
 * loag_image.c - load image (via convert)
 *
 * Copyright (c) 2010 ariel/KotCzarny
 *
 * This file is released under the GPLv2
 *
 */

#ifndef INC_load_image
#define INC_load_image

#ifdef USE_load_image

#include <stdio.h>	// f*, *print*
#include <string.h>	// strlen

// make sure buf is ww*wh*4 bytes long and allocated
/////####################################################################
void load_image(unsigned char *buf, char *name, int ww, int wh, int gray) {
  int o; unsigned char c; FILE *f; char cnvcmd[1024];
  if(strlen(name)>0)
       sprintf(cnvcmd,"if [ -s \"%s\" ]; then convert -resize %dx%d! \"%s\" osc-pix.rgba; fi", name, ww,wh, name);
  else sprintf(cnvcmd,"if [ -s \"osc-pix.jpg\" ]; then convert -resize %dx%d! osc-pix.jpg osc-pix.rgba; fi", ww,wh);
  system(cnvcmd);
  f=fopen("osc-pix.rgba","r"); if(f) { fread(buf,ww*4,wh,f); fclose(f); }
  if(gray==0) for(o=0; o<ww*wh*4; o+=4) { c=buf[o]; buf[o]=buf[o+2]; buf[o+2]=c; }
  else for(o=0; o<ww*wh*4; o+=4) { buf[o/4]=(buf[o]+buf[o+1]+buf[o+2])/3; }
}

#endif
#endif
