#include <math.h>
#include <stdlib.h>
// simon's brain
// requires working gcc, you can use anything you like inside pix function
// no compilation needed, just run: ./osc -p -1 or press F3

// ww - window width, wh - window height, bpp - bytes per pixel
// dst - target buf, src - previous frame buf
// buf2, buf3 - preallocated buffers (not used by the drawing routing,
//              feel free to use as a scratch space

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 int o, o1, x, y, x1, y1, dx=bpp, dy=bpp*ww;
// int rx=rand()/(RAND_MAX/3); int ry=rand()/(RAND_MAX/3);
 for(y=0; y<wh; y++) {
  for(x=0; x<ww; x++) {
   // o - position, should be: 0 <= o <= (ww*dx+y*dy-1)
   o=x*dx+y*dy;
   // simple move + fade
//   x1=x+(sin(-1+2.0*x/ww)*16);
//   y1=y+wh/(y+1);
if(x!=ww/2-1) x1=x+ww/(x-ww/2+1); else x1=x;
if(y!=wh/2-1) y1=y+wh/(y-wh/2+1); else y1=y;
   if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
    dst[0+o]=dst[0+o]*14/32+src[0+o1]*14/32; // blue
    dst[1+o]=dst[1+o]*14/32+src[1+o1]*14/32; // green
    dst[2+o]=dst[2+o]*14/32+src[2+o1]*14/32; // red
  }
 }
}
