#include <stdio.h>
#include <stdlib.h>
#include <math.h>
// map: rotation + dither

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ // int rx=rand()/(RAND_MAX/3); int ry=rand()/(RAND_MAX/3);
 int o, o1, x, y, x1, y1, dx=bpp, dy=bpp*ww;
 int ww2=ww/2, wh2=wh/2;
 int *map=buf3;

 if(map[ww*wh*1]!=0x1234 || map[ww*wh*1+1]!=ww || map[ww*wh*1+2]!=wh) // diff. map
{ printf("\npix: generating transform map..");
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh;
 float fx=0.0,fy=0.0,fr;
// float a=(450.0-fbuf[10])/1.0;
 float b=3.1416/2/wh;
// fx=(450-fbuf[49])/1; // 1kHz
// fy=(450-fbuf[10])/8; // react to 62.5Hz
//printf("ww: %d, wh: %d\n", ww, wh);
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)

   fx=b*(x-ww2);
   fy=b*(y-wh2);
   fr=11.1*sqrt(fx*fx+fy*fy);


   x1=x-fr*sin(fy+((rand() % 100)-50)/100.0);
   y1=y+fr*sin(fx+((rand() % 100)-50)/100.0);

   if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
   map[o]=o1;
  }
 }
 printf("..done\n");
}

 for(y=0; y<wh; y++) {
  for(x=0; x<ww; x++) { o1=x+y*ww; o=o1*4; // o - mem offset, 0 <= o <= (ww*dx+y*dy-1)
if(0) {
    dst[0+o]=+src[0+map[o1]]*24/32; // blue
    dst[1+o]=+src[1+map[o1]]*24/32; // green
    dst[2+o]=+src[2+map[o1]]*24/32; // red
}else{
    dst[0+o]=dst[0+o]*4/32+src[0+map[o1]]*27/32; // blue
    dst[1+o]=dst[1+o]*4/32+src[1+map[o1]]*27/32; // green
    dst[2+o]=dst[2+o]*4/32+src[2+map[o1]]*27/32; // red
}
 }}

}

