// shroom seeder, works best with only sinesweep osc

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define swap(a,b) a ^= b ^= a ^= b;

void putp(unsigned char *tc, int wh, int ww, int y, int x, int c) { int o;
 if(x<0 || x>=ww || y<0 || y>=wh) { return; }
 unsigned int *t=(unsigned int *)tc;
 o=(x+y*ww); t[o]=
+(((t[o]&0xff0000)+(c&0xff0000))/2&0xff0000)
+(((t[o]&0xff00)+(c&0xff00))/2&0xff00)
+(((t[o]&0xff)+(c&0xff))/2&0xff);
;// memcpy(t+o, &c, 4);
}

void putline(unsigned char *t, int wh, int ww, int y0, int x0, int y1, int x1, int c) {
// int X1=x1,Y1=y1,X0=x0,Y0=y0;
 if(x0<0 || x0>=ww || y0<0 || y0>=wh) { return; }
 if(x1<0 || x1>=ww || y1<0 || y1>=wh) { return; }
 int x, steep = abs(y1 - y0) > abs(x1 - x0);
 if(steep) { swap(x0, y0); swap(x1, y1); }  if(x0 > x1) { swap(x0, x1); swap(y0, y1); }
 int deltax = x1 - x0, deltay = abs(y1 - y0); int error = deltax / 2; int ystep, y = y0;
 if(y0 < y1) ystep = 1; else ystep = -1;
 for(x=x0; x<x1; x++)
 { if(steep) putp(t, wh,ww,x,y,c); else putp(t,wh,ww,y,x,c);
  error = error - deltay; if(error < 0) { y = y + ystep; error = error + deltax; }
 }
}

//mbuf - mouse buf: x, y, absolute x, absolute y, buttons/modifiers
// last frame's params mbuf[..+8], array size: 8*25*10 (10s worth of params)

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 int o, o1, x, y, dx=bpp, dy=bpp*ww;
 int ww2=ww/2, wh2=wh/2;
 float *map=(float *)buf3;
 float fx=0.0,fy=0.0,fr;
 float a=0.0,bpi=3.1416/2/wh;

 int c=
 (((int)(127+sin(a*0.56+(frame*1.1)*3.1416*1.5/ww)*127))<<16)
+(((int)(127+sin(a*0.56+(frame*2.5)*3.1416*1.5/ww)*127))<<8)
+(((int)(127+sin(a*0.56+(frame*0.1)*3.1416*1.5/ww)*127)));

 float x1,y1;

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform map..");
 if(mbuf[4]==0) {mbuf[0]=ww2; mbuf[1]=wh2;}
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 float fx=0.0,fy=0.0,fr;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
//   fx=b*(x-mbuf[0]); fy=b*(y-mbuf[1]);   fr=64*sqrt(fx*fx+fy*fy);
   fr=2.0;
   x1=x-fr*sin(fy);
   y1=y+fr*sin(fx);

//   if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
   map[o]=o1;
  }
 }
 printf("..done\n");
}

int i,c1,c2,c3,c4,x0,y0;// unsigned char rgb[4];
float px,py,Px,Py,r;
// o.o
if(1) for(y=1; y<wh-1; y++) {
  for(x=1; x<ww-1; x++) {

   fx=0.25*(x-ww2);
   fy=0.35*(y-wh2);
   fr=0.1*sqrt(fx*fx+fy*fy);

   x1=x-fr*sin(fy)*sin(fx);
   y1=y+fr*cos(fx)*sin(fy);

    if(x1<0 || x1>=ww || y1<0 || y1>=wh) {x1=0; y1=0;}
    o=4*(x+y*ww);

x0=floorf(x1);
y0=floorf(y1);

px=x1-x0; Px=1.0-px;
py=y1-y0; Py=1.0-py;
//if(x%200==0 || y%200==0) printf("r:%f  x:%d x0:%d x1:%f  px:%f Px:%f\n", r, x,x0,x1,px,Px);

for(i=2;i>=0;i--)
{
 c1=src[i+((int)(x0  +y0*ww))*4];
 c2=src[i+((int)(x0+1+y0*ww))*4];
 c3=src[i+((int)(x0  +(y0+1)*ww))*4];
 c4=src[i+((int)(x0+1+(y0+1)*ww))*4];
 dst[i+o]=( (c1*px+c2*Px)*py + (c3*px+c4*Px)*Py )*0.99;
// dst[i+o]=(c1*px*py+c2*Px*py+c3*px*Py+c4*Px*Py)*0.999;
//if(x%200==0 || y%200==0)printf("0x%08x 0x%08x 0x%08x 0x%08x 0x%08x\n",c1,c2,c3,c4,dst[i+o]);
}
//r=((int)((c1&0xff0000)*px*py+(c2&0xff0000)*Px*py+(c3&0xff0000)*px*Py+(c4&0xff0000)*Px*Py)&0xff0000)>>16;
//g=((int)((c1&0xff00)*px*py+(c2&0xff00)*Px*py+(c3&0xff00)*px*Py+(c4&0xff00)*Px*Py)&0xff00)>>8;
//b=((int)((c1&0xff)*px*py+(c2&0xff)*Px*py+(c3&0xff)*px*Py+(c4&0xff)*Px*Py)&0xff);
//printf("%d %08x, ",o,c);
//dst[2+o]=r;dst[1+o]=g;dst[0+o]=b;
//memcpy(dst[o],c,4);
//    dst[0+o]=+src[0+o1]*31/32; // blue
//    dst[1+o]=+src[1+o1]*31/32; // green
//    dst[2+o]=+src[2+o1]*31/32; // red
}}

/*
if(0) for(y=0; y<wh; y++) {
  for(x=0; x<ww; x++) { o1=x+y*ww; o=o1*4;
if(1) {
    dst[0+o]=+src[0+map[o1]]*31/32; // blue
    dst[1+o]=+src[1+map[o1]]*31/32; // green
    dst[2+o]=+src[2+map[o1]]*31/32; // red
}else{
    dst[0+o]=dst[0+o]*4/32+src[0+map[o1]]*28/32; // blue
    dst[1+o]=dst[1+o]*4/32+src[1+map[o1]]*28/32; // green
    dst[2+o]=dst[2+o]*4/32+src[2+map[o1]]*28/32; // red
}

 }}
*/

}
