// pupnik's rainbow dust with gamerand

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define MAXXLAT 1228800

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
  int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
  unsigned char *buf2, unsigned char *buf3)
{

int i, o, o1, x, y, x1, y1, dx=bpp, dy=bpp*ww;
int ww2=ww/2, wh2=wh/2;

struct xlatr{ signed short xlatx; signed short xlaty; }xlattable[MAXXLAT];
float fx,fy,fr=0.0;
float curerry,curerrx; // error accumulators for floyd-steinberg dither which is broken
// GAMERAND Assumes unsigned int is a 32-bit integer.  Change as needed
unsigned int s_GameRand_High = 1;
unsigned int s_GameRand_Low = 1 ^ 0x49616E42;

int gamerand(void) {
    s_GameRand_High = (s_GameRand_High << 16) + (s_GameRand_High >> 16);
    s_GameRand_High += s_GameRand_Low;
    s_GameRand_Low += s_GameRand_High;
    return s_GameRand_High;
}
void sgamerand(unsigned int seed) {
        s_GameRand_High = seed;
        s_GameRand_Low = seed ^ 0x49616E42;
}

if(frame < 1) { 
  printf("\npix: generating %i,%i transform map...",ww,wh);
  for(y=0; y<wh; y++) { 
    for(x=0; x<ww; x++) { 
      fx=(float)(+-ww2);
      fy=(float)(y-wh2);
      fr=0.43*sqrt(fx*fx+fy*fy);
      o=x+y*ww;  // o is an index to the destination 
      xlattable[o].xlatx = 1
                           +(fx+-fr*sin(fy/236.0)+ww2)/47
   //+ (gamerand()%2)-1;
   +(gamerand()%2)-1;
   ;
      xlattable[o].xlaty = 2
                           +(fy+-fr*cos(fx/384.0)+wh2)/53
   +(gamerand()%4)-2
   ;
  } }
  printf("done\n");
}
// apply pixel translation with wrapping (toroidal) and fade out colors
int odest, array_size, seed, roff;
o=0; array_size=ww*wh;
roff=1; seed=913248;
for(y=0; y<wh; y++) { for(x=0; x<ww; x++) { // iterate through bitmap
    o=(x+y*ww);  // o is an index to the x*y array 
    odest=(int)(o+xlattable[o].xlatx
	      + ((((x+frame+y) * 1083407) ^ 239823)%4)  // random distortion/blur
	      + ww*(((((x+frame+y+1) * 1083407) ^ 239823)%4)-3) // random distortion blur y
	      + (sin((y+frame)/82.1)*4.18*cos((frame+x)/81.0))
	      + ww*(int)(
		     + sin(0.01*x*(frame%314)/100)
	             + (cos((y-frame)/82.1)*4.18*sin((frame-x)/81.0))
		     + xlattable[o].xlaty) ); // calculate source pixel via xlation table 
    if (odest < 0) odest=(array_size-1)-((-odest-1)%array_size); else odest=odest%array_size; 
    for(i=2;i>=0;i--) { // loop through r,g,b
      if(src[i+odest*4]>3) dst[i+o*4]=src[i+odest*4]-3; else dst[i+o*4]=0; //copy xlated src to dest
    } 
} } }

