// ami sine - 3d glasses ver

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

#define swap(a,b) a ^= b ^= a ^= b;

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[360*100];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
}
float cost(float a) { return sint(a+3.14159265/2.0); }

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 union color *isrc=(union color *)src;
 union color *idst=(union color *)dst;
 int o, o1, x, y, dx=bpp, dy=bpp*ww;
 int ww2=ww/2, wh2=wh/2;
 float *map=(float *)buf3;
 float fx=0.0,fy=0.0,fr;
 float a=0.0; //,bpi=3.1416/2/wh;

 unsigned char r,g,b; 

 float x1,y1;

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform cache..");
 if(mbuf[4]==0) {mbuf[0]=ww2; mbuf[1]=wh2;}
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 float fx=0.0,fy=0.0,fr;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
   fx=3.1416*(x-ww2)/ww;
   fy=3.1416*(y-wh2)/wh;
   fr=sqrt(fx*fx+fy*fy)*10.0*4.0;

   //if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
   map[o]=fr;
  }
 }
 for(x=0;x<36000;x++) sin_tab[x]=sin(2.0*3.14159265*x/36000.0);
 printf("..done\n");
}


union color c1,c2,c3,c4,cc;
int o0,i,x0,y0; float px,py,Px,Py,pp,pP,Pp,PP;
//memset(dst,0,ww*4); memset(dst+ww*(wh-1)*4,0,ww*4);
//for(i=0;i<wh;i++){ memset(dst+(i*ww*4),0,4); memset(dst+(i*ww*4+(ww-1)*4),0,4); }
float f=(300.0-fbuf[9])/30.0;
for(y=0;y<wh-1;y++) {
 for(x=0;x<ww;x+=4) { o=(x+y*ww); fx=1.0*x/ww; fy=1.0*y/wh;
//r=127+127.0*(sint(4.0*y/wh2*sint(0.02*frame)+sint(sint(0.1*frame)+20.0*x/ww2+sint(sint(0.1*frame)*12.0+100.0*y/ww2))));
r=127+127.0*
(sint(4.0*y/wh2+sint(30.0*x/ww2+sint(sint(0.01*frame)*23.0+100.0*y/ww2*sint(3.1416*x/ww2)))));
g=127+127.0*
(sint(4.0*y/wh2+sint(30.0*x/ww2+sint(sint(0.01*frame)*22.0+100.0*y/ww2*sint(3.1416*x/ww2)))));
b=127+127.0*
(sint(4.0*y/wh2+sint(30.0*x/ww2+sint(sint(0.01*frame)*21.0+100.0*y/ww2*sint(3.1416*x/ww2)))));
//  g=0;//127+127.0*(sint(21.0*y/wh*sint(2.0*x/ww+frame*0.02)+sint(14.0*x/ww+y*0.2+f*0.1)));
//  b=0;//127+127.0*(sint(22.0*y/wh*sint(2.1*x/ww+frame*0.022)+sint(13.0*x/ww+y*0.11+f*3.01)));
  idst[o].s.r=r; idst[o].s.g=g; idst[o].s.b=b;
  for(i=1;i<4;i++) idst[o+i].i=idst[o].i;
}}


}
