// siny tails

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[36000]; static int sint_inited=0;
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { int i; for(i=0;i<36000;i++) sin_tab[i]=sin(2.0*3.14159265*i/36000.0); i=0; 
 sint_inited=1; printf("sint inited\n"); }


void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ int x,y,r,g,b; unsigned int *idst=(unsigned int *)dst;
 union color c0,*csrc=(union color *)src;
 if(!sint_inited) sint_init();

 int xx,yy; float di,df;
 for(y=0; y<wh; y++) for(x=0; x<ww; x++)
 { r=0; g=0; b=0;
  { di=1.0*x/ww+10.0*y/wh+sint(frame*0.1)*frame/20.0; df=(sint(di)*sint(di)*2.0/4.0+0.5);
c0.i=csrc[x+0+y*ww].i; r+=c0.s.r*df;g+=c0.s.g*df;b+=c0.s.b*df;
c0.i=csrc[x+1+y*ww].i; r+=c0.s.r*df;g+=c0.s.g*df;b+=c0.s.b*df;
c0.i=csrc[x+2+y*ww].i; r+=c0.s.r*df;g+=c0.s.g*df;b+=c0.s.b*df;
  }
  r=r/3; g=g/3; b=b/3;

  idst[x+y*ww]=(r<<16)|(g<<8)|(b);
 }
}
