// spiral fan

#define MAX(a,b) (a>b?a:b)
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

int sint_inited=0; static float sin_tab[36000];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { if(sint_inited) return; sint_inited=1;
 int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }


void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ unsigned int *isrc=(unsigned int *)src, *idst=(unsigned int *)dst, *ibuf2=(unsigned int *)buf2;
 union color *csrc=(union color *)src, *cdst=(union color *)dst, c; c.i=0;
 int o,x,y,ww2=ww/2,wh2=wh/2; sint_init(); // if(mbuf[4]&0x400) {}

 float z,r,x1,y1,fr,fg,fb;
 fr=frame*0.72;
 fg=frame*0.61;
 fb=frame*0.53;
 for(y=1;y<wh;y++)
 {
  for(x=1;x<ww;x++) { o=x+y*ww;
   x1=5.0*(x-ww2)/wh2; y1=5.0*(y-wh2)/wh2; r=sqrt(x1*x1+y1*y1);
//   z=1/(1.0+r)*(x1*sint(4.0*r-fr)+y1*cost(4.0*r-fr));   c.s.r=127.0+127.0*z;
//   z=1/(1.0+r)*(x1*sint(4.0*r-fg)+y1*cost(4.0*r-fg));   c.s.g=127.0+127.0*z;
//   z=1/(1.0+r)*(x1*sint(4.0*r-fb)+y1*cost(4.0*r-fb));   c.s.b=127.0+127.0*z;

// inner spiral waves
//   z=1/(1.0+r)*(x1*sint(4.0*r-fg)+y1*cost(4.0*r-fg));   c.s.g=127.0+127.0*z;
// droplet waves
//   z=cost(r-fr);   c.s.g=127.0+127.0*z;

   z=1/(1.0+r)*(x1*sint(4.0/r+fg)+y1*cost(4.0/r+fg));   c.s.g=127.0+127.0*z;

   c.s.r=(c.s.r*2+csrc[o].s.r*5)/8;
   c.s.g=(c.s.g*2+csrc[o].s.g*5)/8;
   c.s.b=(c.s.b*2+csrc[o].s.b*5)/8;
   cdst[o].i=c.i;
  }
 }

}
