// psycho patches of colours

#define MAX(a,b) (a>b?a:b)
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

int sint_inited=0; static float sin_tab[36000];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { if(sint_inited) return; sint_inited=1;
 int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }

int map_inited=0;
void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ unsigned int *isrc=(unsigned int *)src, *idst=(unsigned int *)dst, *ibuf2=(unsigned int *)buf2;
 union color *csrc=(union color *)src, *cdst=(union color *)dst, c; c.i=0;
 int o,x,y,ww2=ww/2,wh2=wh/2; sint_init(); // if(mbuf[4]&0x400) {}

if(map_inited<2) { map_inited++; FILE *f1; char conv[2048];
 sprintf(conv,"convert -resize %dx%d! spiral.png spiral.gray", ww,wh); system(conv);
 f1=fopen("spiral.gray", "r"); fread(buf3,ww*wh,1,f1); fclose(f1);
 for(o=0;o<ww*wh;o++) { memset(buf2+o*4,buf3[o],4); }
}

 int x0,y0,o0,o4; float px,py,Px,Py,pp,pP,Pp,PP,x1,y1,x2,y2; union color cc,c1,c2,c3,c4;
 float z,r,xc,yc,fr,fg,fb,cf,sf,xww2,ywh2,a=0;
 fr=frame*0.022;
 fg=frame*0.161;
 fb=frame*0.159;
 cf=cost(fr)*0.65;
 sf=sint(fr)*0.65;
 for(y=0;y<wh;y++)
 { ywh2=y-wh2;
  for(x=0;x<ww;x++) { o=x+y*ww; o4=o*4; xww2=x-ww2;
   xc=5.0*(xww2)/wh2; yc=5.0*(ywh2)/wh2;
//   r=sqrt(xc*xc+yc*yc);
//   r=sqrt(x*x+y*y);
//   x1=5.0*(x-ww2)/wh2; y1=5.0*(y-wh2)/wh2; r=sqrt(x1*x1+y1*y1);
// inner spiral waves
//   z=20.0/(1.0+r)*(xc*sint(4.0*r-fg)+yc*cost(4.0*r-fg)); //  c.s.g=127.0+127.0*z;
// droplet waves
//   z=cost(r-fr);   c.s.g=127.0+127.0*z;
// rainbow logarithmic spiral wave
//   z=1.0/(1.0+r)*(x1*sint(4.0/r+fr)+y1*cost(4.0/r+fr));   c.s.r=127.0+127.0*z;
//   z=1.0/(1.0+r)*(x1*sint(4.0/r+fg)+y1*cost(4.0/r+fg));   c.s.g=127.0+127.0*z;
//   z=1.0/(1.0+r)*(x1*sint(4.0/r+fb)+y1*cost(4.0/r+fb));   c.s.b=127.0+127.0*z;

//  x1=x+6.0/(1.0+r)*(xc*sint(4.0*r-fg)+yc*cost(4.0*r-fg));
//  y1=y+6.0/(1.0+r)*(xc*sint(4.0*r-fg)+yc*cost(4.0*r-fr));

// spiral distort + rotation
//  x1=ww2+0.67(x-ww2)*cost(fr)-0.67*(y-wh2)*sint(fr);
//  y1=wh2+0.67*(x-ww2)*sint(fr)+0.67*(y-wh2)*cost(fr);

// spiral, distort, rotation
//  r=sqrt(xww2*xww2+ywh2*ywh2)*0.05;
//  z=1.0/(1.0+r)*(xww2*sint(r)+ywh2*cost(r));
//  x1=z+ww2+cf*(x-ww2)-sf*(y-wh2);
//  y1=z+wh2+sf*(x-ww2)+cf*(y-wh2);

// pupnik's weave
//  x1=z+ww2+0.75*(x-ww2)*cost(r/10)+0.75*(y-wh2)*sint(r/10);
//  y1=z+wh2+0.75*(x-ww2)*sint(r/10)-0.75*(y-wh2)*cost(r/10);

// zoomer with a twist
//  x1=x+2*sint(fr)*(x-ww2);
//  y1=y+2*sint(fr)*(y-wh2);

// zoomer with a matrix
//  x1=(int)(x+ww+1.0*sint(fr*2)*(x-ww2))%ww;
//  y1=(int)(y+wh+1.0*sint(fr*2)*(y-wh2))%wh;

//  x1=ww2+cf*(x-ww2)-sf*(y-wh2);
//  y1=wh2+sf*(x-ww2)+cf*(y-wh2);

// interferofun
// x1=x+0.01*r*sint(fr+x-ww2);
// y1=y+0.01*r*cost(fr+y-wh2);

// glass tiles
// x1=x+0.02*r*sint((8*fr+x-ww2)/8.0);
// y1=y+0.02*r*cost((8*fr+y-wh2)/8.0);

// acid (twister)
// x1=x+0.003*r*sint((8.0*fr+x-ww2)/8.0);
// y1=y+0.003*r*cost((8.0*fr+y-wh2)/8.0);

// acid (in&out)
// x1=x+0.02*r*sint(0.01*x)*sint((8.0*fr)/16.0);
// y1=y+0.02*r*sint(0.01*y)*cost((8.0*fr)/16.0);

// flipper
// x1=x+2.0*sint(0.01*x)/sint((8.0*fr)/16.0);
// y1=y+2.0*sint(0.01*y)/cost((8.0*fr)/16.0);

// sombrero lens
// x1=x+2.0*cost((xc*xc+yc*yc+fr*10)/4.0)*(13.0+xc*xc+yc*yc);
// y1=y+2.0*cost((xc*xc+yc*yc+fr*10)/4.0)*(13.0+xc*xc+yc*yc);

//  x1=x-0.125*r*(cost(1.0*3.1416*(y-wh2)/wh2+fr)*sint(1.0*3.1416*(x-ww2)/ww2-fr));
//  y1=y-0.125*r*(sint(1.0*3.1416*(y-wh2)/wh2+fr)*cost(1.0*3.1416*(x-ww2)/ww2+fr));
//r(d) = c tan(d/R); a

// x1=x+0.01*r*sint(fr+y-ww2)*cost(fr*0.1);
// y1=y+0.01*r*cost(fr+x-wh2)*sint(fr*0.1);

// Fz(x,y)=[8*x^2*y^2*e^(0-r)] / r
//         r=x^2+y^2
//Fz(x,y)=12*cos((x^2+y^2)/4)/(3+x^2+y^2)
// r=(x-ww2)*(x-ww2)+(y-wh2)*(y-wh2);
//  r=sqrt((x-ww2)*(x-ww2)+(y-wh2)*(y-wh2));
 x1=x+30.1*cost((xc*xc+yc*yc-fr*10)/4.0)/(1.0+xc*xc+yc*yc);
 y1=y+31.1*cost((xc*xc+yc*yc+fr*10)/2.0)/(1.0+xc*xc+yc*yc);

if(0) {
 x0=(int)(x1); y0=(int)(y1); if(x0<0) x0=-x0; if(y0<0) y0=-y0; x0%=ww; y0%=wh;
 o0=x0+y0*ww; idst[o]=ibuf2[o0];
// dst[2+o4]=src[o0*4+2]*96/100;dst[1+o4]=src[o0*4+1]*96/100;dst[0+o4]=src[o0*4+0]*96/100;
} else {
 // bilinearizer. cute, but slower
 x0=(int)(x1); y0=(int)(y1); Px=x1-x0; px=1.0-Px; Py=y1-y0; py=1.0-Py;
 if(x0<0) x0=-x0; if(y0<0) y0=-y0; x0%=ww; y0%=wh;
 o0=x0+y0*ww;
// limits done by above lines
// if(x0<2 || x0>ww-2 || y0<2 || y0>wh-2) o0=0; else  o0=x0+y0*ww; // proper
// if(x0<2 || x0>ww-2 || y0<2 || y0>wh-2) continue; else  o0=x0+y0*ww; // proper
// if(x0<0 || x0>=ww || y0<0 || y0>=wh) { idst[o]=0xf000f0; continue; } else  o0=x0+y0*ww;
// o0=x0+y0*ww; if(o0<0 || o0>ww*wh*bpp) o0=o4; // faster
 pp=px*py; pP=px*Py; Pp=Px*py; PP=Px*Py;
 c1.i=ibuf2[o0];
 c2.i=ibuf2[o0+1];
 c3.i=ibuf2[o0+ww];
 c4.i=ibuf2[o0+1+ww];

if(1) { // bilinearizer default
 cc.s.b=(c1.s.b*pp+c2.s.b*Pp+c3.s.b*pP+c4.s.b*PP)*96/100;
 cc.s.g=(c1.s.g*pp+c2.s.g*Pp+c3.s.g*pP+c4.s.g*PP)*96/100;
 cc.s.r=(c1.s.r*pp+c2.s.r*Pp+c3.s.r*pP+c4.s.r*PP)*96/100;

 if(1) {
  cc.s.b=cc.s.b*0.9*cost(yc-fb)*sint(xc+fb)*sint((fr)*0.1*3.1416*1.5);
  cc.s.g=cc.s.g*0.9*cost(yc+fg)*sint(xc+fg)*sint((fr)*2.5*3.1416*1.5);
  cc.s.r=cc.s.r*0.9*cost(yc-fr)*sint(xc-fr)*sint((fr)*1.1*3.1416*1.5);
 }
}

 dst[2+o4]=cc.s.r; dst[1+o4]=cc.s.g; dst[0+o4]=cc.s.b;
// idst[o]=cc.i;
}


//   c.s.g=127.0+127.0*z;
//   c.s.r=(c.s.r*2+csrc[o].s.r*5)/8; c.s.g=(c.s.g*2+csrc[o].s.g*5)/8; c.s.b=(c.s.b*2+csrc[o].s.b*5)/8;
//   cdst[o].i=c.i;
  }
 }

}
