// hexapixelated

#define MAX(a,b) (a>b?a:b)
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

int sint_inited=0; static float sin_tab[36000];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { if(sint_inited) return; sint_inited=1;
 int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }


int map_inited=0;
void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ unsigned int *isrc=(unsigned int *)src, *idst=(unsigned int *)dst, *ibuf2=(unsigned int *)buf2;
 union color *csrc=(union color *)src, *cdst=(union color *)dst, c; c.i=0;
 int o,x,y,ww2=ww/2,wh2=wh/2; sint_init(); // if(mbuf[4]&0x400) {}

if(map_inited<2) { map_inited++; FILE *f1; char conv[2048];
 sprintf(conv,"convert -resize %dx%d! spiral.png spiral.gray", ww,wh); system(conv);
 f1=fopen("spiral.gray", "r"); fread(buf3,ww*wh,1,f1); fclose(f1);
 for(o=0;o<ww*wh;o++) { memset(buf2+o*4,buf3[o],4); }
}

 int x0,y0,o0,o4; float px,py,Px,Py,pp,pP,Pp,PP,x1,y1,x2,y2; union color cc,c1,c2,c3,c4;
 float z,r,xc,yc,fr,fg,fb,cf,sf,xww2,ywh2,a=0;
 fr=frame*0.022; fg=frame*0.0361; fb=frame*0.0359; cf=cost(fr)*0.65; sf=sint(fr)*0.65;

 int om=ww*wh, i,j,gr=16, gr2=gr/2, gr0=gr*2; for(y=0;y<wh;y+=gr) { ywh2=y-wh2; for(x=0;x<ww;x+=gr) { o=x+y*ww; o4=o*4; xww2=x-ww2;
 if(y%gr0==0) x0=x; else x0=x+gr2;
 for(j=-gr2;j<gr2;j++)
 for(i=-gr2;i<gr2;i++)
 { o0=x0+i+(y+j)*ww; if(o0<0 || o0>=om) continue;
  if(abs(i)+abs(j)<gr2*1.5) {
   if(0) idst[o0]=isrc[o];
   else { // temporal blend
    cc.i=ibuf2[o];
    cc.s.r=(cc.s.r*1+csrc[o].s.r*7)/8;
    cc.s.g=(cc.s.g*1+csrc[o].s.g*7)/8;
    cc.s.b=(cc.s.b*1+csrc[o].s.b*7)/8;
    idst[o0]=cc.i;
   }
  } else {
   cc.i=isrc[o0];
   cc.s.r=(cc.s.r*7)/8;
   cc.s.g=(cc.s.g*7)/8;
   cc.s.b=(cc.s.b*7)/8;
   idst[o0]=cc.i;
  }
 }

}}
}
